--- u-boot-2011.06_original/drivers/cnc1900/df/df.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/cnc1900/df/df.c	2015-05-18 19:41:06.764203000 +0800
@@ -0,0 +1,1668 @@
+/****************************************************************************
+ * Copyright (C) 2011 Cavium Inc.
+ * All rights reserved
+ *
+ * [RELEASE HISTORY]                           
+ * VERSION  DATE       AUTHOR                  DESCRIPTION
+ * 0.1      11-10-10       Jia Ma           		Original
+ ****************************************************************************
+ */
+#include <linux/types.h>
+#include <common.h>
+#include <asm/byteorder.h>
+#include <malloc.h>
+#include "cnc_util.h"
+#include "tve0_1900.h"
+#include "tve1_1900.h"
+#include "df_reg_def.h"
+#include "df_reg_fmt.h"
+#include "../../../board/cavium/cnc1900/power_clock.h"
+#include "df.h"
+#include "command.h"
+
+#define df_write(a,b) 	(*(volatile unsigned int*)(a) = (b))
+#define df_write16(a,b) 	(*(volatile unsigned short*)(a) = (b))
+#define df_write8(a,b) 		(*(volatile unsigned char*)(a) = (b))
+
+#define df_read(a) 		(*(volatile unsigned int*)(a))
+#define df_read16(a) 		(*(volatile unsigned short*)(a))
+#define df_read8(a) 		(*(volatile unsigned char*)(a))
+
+static int __Is_ColorBar = 0;
+//#define DEBUG_DF  
+#ifdef DEBUG_DF
+#define df_printf printf
+#else
+#define df_printf(fmt,args...)
+#endif
+static unsigned char __tve0_reg_read(unsigned char addr_base)
+{
+	unsigned char data_rd;
+	unsigned int addr ;
+	addr = TVE0_REG_BASE +(addr_base);
+	data_rd = df_read8(addr);
+
+	return data_rd;
+}
+
+static void __tve0_reg_write(unsigned char addr_base, unsigned char data)
+{
+	unsigned char data_rd;
+	unsigned int addr ;
+	addr = TVE0_REG_BASE +(addr_base);
+
+	df_write8(addr,data);
+	data_rd = df_read8(addr);
+
+	if(data_rd != data)
+	{
+		printf("TVE0: Reg Write ERROR: addr_base = %x, wr_data =%x,rd_data = %x\n",\
+				addr_base,data,data_rd);
+	}
+}
+
+int InitTVE0Raw(TVOUT_MODE DispFormat , int EnableColorBar)
+{
+	int i = 0;
+	int VIDEO_TYPE  = TVOUT_MODE_576I;
+
+	int IsHD = 0;
+	int IsProgressive = 0;
+
+
+	//Map the Display Format Value to TVE0 Format Value
+	switch (DispFormat)
+	{
+		case TVOUT_MODE_SECAM:
+			VIDEO_TYPE = TYPE_SECAM;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_N:
+			VIDEO_TYPE = TYPE_PAL_N;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_M:
+			VIDEO_TYPE = TYPE_PAL_M;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_CN:
+			VIDEO_TYPE = TYPE_PAL_CN;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_576I:
+			VIDEO_TYPE = TYPE_PAL;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_480I:
+			VIDEO_TYPE = TYPE_NTSC;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_1080I30:
+			VIDEO_TYPE = TYPE_1080i30;
+			IsHD = 1;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_1080I25:
+			VIDEO_TYPE = TYPE_1080i;
+			IsHD = 1;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_720P60:
+			VIDEO_TYPE = TYPE_720p60;
+			IsHD = 1;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_720P50:
+			VIDEO_TYPE = TYPE_720p50;
+			IsHD = 1;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_480P:
+			VIDEO_TYPE = TYPE_480p;
+			IsHD = 0;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_576P:
+			VIDEO_TYPE = TYPE_480p;
+			IsHD = 0;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_1080P24:
+		case TVOUT_MODE_1080P25:
+		case TVOUT_MODE_1080P30:
+		case TVOUT_MODE_1080P50:
+		case TVOUT_MODE_1080P60:
+			return 0;
+		default:
+			VIDEO_TYPE = TYPE_PAL;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+	}
+	printf("IsProgressive=%d,IsHd=%d\n",IsProgressive,IsHD);
+	//Hold TVE0 Timing
+	__tve0_reg_write(TVE0_REG[0][REG_ADDR],0x1);
+
+	//DEBUG_PRINTF("[TVE0: INFO]probe REV_ID ..%d\n",TVE0_REG[1][REG_ADDR]);
+
+	for (i=2; i<TVE0_REG_NUM; i++)
+	{
+		//DEBUG_PRINTF("TVE0: ADDR=%03x,WriteDATA=%03x\n",TVE0_REG[i][REG_ADDR],TVE0_REG[i][VIDEO_TYPE]);
+		__tve0_reg_write(TVE0_REG[i][REG_ADDR],TVE0_REG[i][VIDEO_TYPE]);
+	}
+
+	if (EnableColorBar)
+	{
+		unsigned char  RegValue = 0;
+		RegValue = __tve0_reg_read(0x2);
+		RegValue |= (1 << 5);
+		__tve0_reg_write(0x2,RegValue);
+	}
+	__tve0_reg_write(TVE0_REG[0][REG_ADDR],0x0);
+	df_printf("out InitTVE0Raw\n");
+	return 0;
+}
+
+static unsigned char __tve1_reg_read(unsigned char addr_base)
+{
+	unsigned char data_rd;
+	unsigned int addr ;
+	addr = TVE1_REG_BASE +(addr_base);
+	data_rd = df_read8(addr);
+	return data_rd;
+}
+
+static void __tve1_reg_write(unsigned char addr_base, unsigned char data)
+{
+	unsigned char data_rd;
+	unsigned int addr ;
+	addr = TVE1_REG_BASE +(addr_base);
+
+	df_write8(addr,data);
+	data_rd = df_read8(addr);
+	if(data_rd != data){
+		//		printf("TVE1: Reg Write ERROR: addr_base = %02x, wr_data =%08x,rd_data = %08x\n",
+		//				addr_base,data,data_rd);
+	}
+}
+
+int InitTVE1Raw( TVOUT_MODE DispFormat , int EnableColorBar)
+{
+	int i = 0;
+	int VIDEO_TYPE  = TVOUT_MODE_576I;
+
+	int IsHD = 0;
+	int IsProgressive = 0;
+
+
+	//Map the Display Format Value to TVE1 Format Value
+	switch (DispFormat){
+		case TVOUT_MODE_SECAM:
+			VIDEO_TYPE = TYPE_SECAM;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_N:
+			VIDEO_TYPE = TYPE_PAL_N;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_M:
+			VIDEO_TYPE = TYPE_PAL_M;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_CN:
+			VIDEO_TYPE = TYPE_PAL_CN;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_576I:
+			VIDEO_TYPE = TYPE_PAL;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_480I:
+			VIDEO_TYPE = TYPE_NTSC;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_1080I30:
+		case TVOUT_MODE_1080I25:
+			VIDEO_TYPE = TYPE_1080i;
+			IsHD = 1;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_720P60:
+			VIDEO_TYPE = TYPE_720p60;
+			IsHD = 1;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_720P50:
+			VIDEO_TYPE = TYPE_720p50;
+			IsHD = 1;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_480P:
+			VIDEO_TYPE = TYPE_480p;
+			IsHD = 0;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_576P:
+			VIDEO_TYPE = TYPE_480p;
+			IsHD = 0;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_1080P24:
+		case TVOUT_MODE_1080P25:
+		case TVOUT_MODE_1080P30:
+			return 0;
+		default:
+			VIDEO_TYPE = TYPE_PAL;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+	}
+	//printascii("1111111111\n");
+	//Hold TVE1 Timing
+
+	printf("Init TVE1Raw  IsProgressive=%d,IsHd=%d\n",IsProgressive,IsHD);
+	__tve1_reg_write(TVE1_REG[0][REG_ADDR],0x1);
+	//DEBUG_PRINTF("[TVE1: INFO]probe REV_ID ..%d\n",TVE1_REG[1][REG_ADDR]);
+	//printascii("222222222222\n");
+
+	for (i=2; i<TVE1_REG_NUM; i++)
+	{
+		//		printf("***TVE1: ADDR=%03x,WriteDATA=0x%08x\n",TVE1_REG[i][REG_ADDR],TVE1_REG[i][VIDEO_TYPE]);
+		__tve1_reg_write(TVE1_REG[i][REG_ADDR],TVE1_REG[i][VIDEO_TYPE]);
+	}
+
+	if (EnableColorBar)
+	{
+		unsigned char RegValue = 0;
+		RegValue = __tve1_reg_read(0x2);
+		RegValue |= (1 << 5);
+		__tve1_reg_write(0x2,RegValue);
+	}
+	__tve1_reg_write(TVE1_REG[0][REG_ADDR],0x0);
+
+	return 0;
+}
+
+static int dfreg_ctrl[16] =
+{
+	VPP_REG_GLB_CTRL_H_UPDATE_REG,VPP_REG_GLB_CTRL_M_UPDATE_REG,VPP_REG_GLB_CTRL_C_UPDATE_REG,VPP_REG_GLB_CTRL_SETTING,VPP_REG_GLB_CTRL_CLK_SETTING,
+	VPP_REG_GLB_CTRL_INT_STA_COP,VPP_REG_GLB_CTRL_INT_MSK_COP,VPP_REG_GLB_CTRL_INT_STA_HOST,VPP_REG_GLB_CTRL_INT_MSK_HOST,VPP_REG_GLB_CTRL_SCALE_COEF3,
+	VPP_REG_GLB_CTRL_SCALE_COEF4,VPP_REG_GLB_CTRL_SCALE_COEF6,VPP_REG_GLB_CTRL_CPU_WQ,VPP_REG_GLB_CTRL_COP_RQ,VPP_REG_GLB_CTRL_HAND_STATUS,VPP_REG_GLB_CTRL_TG_SETTING,
+};
+
+static int dfreg_gfx[2][14] =
+{
+	{VPP_REG_GFX_UI1_CTRL,VPP_REG_GFX_UI1_ALPHA_CTRL,VPP_REG_GFX_UI1_SIZE,VPP_REG_GFX_UI1_KEY_RED,VPP_REG_GFX_UI1_KEY_BLUE,VPP_REG_GFX_UI1_KEY_GREEN,
+		VPP_REG_GFX_UI1_BUF_START,VPP_REG_GFX_UI1_LINE_PITCH,VPP_REG_GFX_UI1_X_POSITON,VPP_REG_GFX_UI1_Y_POSITON,VPP_REG_GFX_UI1_BUF_START_3D,
+		VPP_REG_GFX_UI1_A8,VPP_REG_GFX_UI1_PHASE,VPP_REG_GFX_UI1_COEFF_GID,
+	},
+	{VPP_REG_GFX_UI2_CTRL,VPP_REG_GFX_UI2_ALPHA_CTRL,VPP_REG_GFX_UI2_SIZE,VPP_REG_GFX_UI2_KEY_RED,VPP_REG_GFX_UI2_KEY_BLUE,VPP_REG_GFX_UI2_KEY_GREEN,
+		VPP_REG_GFX_UI2_BUF_START,VPP_REG_GFX_UI2_LINE_PITCH,VPP_REG_GFX_UI2_X_POSITON,VPP_REG_GFX_UI2_Y_POSITON,VPP_REG_GFX_UI2_BUF_START_3D,
+		VPP_REG_GFX_UI2_A8,VPP_REG_GFX_UI2_PHASE,VPP_REG_GFX_UI2_COEFF_GID,
+	},
+};
+
+static int dfreg_comp[9] =
+{
+	VPP_REG_COMP_B2_BACK_GROUND,VPP_REG_COMP_B2_Z_ORDER,VPP_REG_COMP_B2_DEFAULT_ALPHA,VPP_REG_COMP_COLOR_ADJUST,VPP_REG_COMP_SHARP_Y_CTRL,
+	VPP_REG_COMP_SHARP_C_CTRL,VPP_REG_COMP_B3_BACK_GROUND,VPP_REG_COMP_B3_Z_ORDER,VPP_REG_COMP_B3_DEFAULT_ALPHA
+};
+
+static int dfreg_outif[2][9] =
+{
+	{VPP_REG_TG1_CTRL,VPP_REG_TG1_X_SIZE,VPP_REG_TG1_Y_SIZE,VPP_REG_TG1_HSYNC,VPP_REG_TG1_VSYNC,
+		VPP_REG_TG1_VGA_LEVEL,VPP_REG_TG1_V_START_LINE,VPP_REG_TG1_STA_DISP_SIZE,VPP_REG_TG1_STA_LINE
+	},
+	{VPP_REG_TG2_CTRL,VPP_REG_TG2_X_SIZE,VPP_REG_TG2_Y_SIZE,VPP_REG_TG2_HSYNC,VPP_REG_TG2_VSYNC,
+		VPP_REG_TG2_VGA_LEVEL,VPP_REG_TG2_V_START_LINE,VPP_REG_TG2_STA_DISP_SIZE,VPP_REG_TG2_STA_LINE
+	},
+};
+#if 0
+static int dfreg_video0[41] =
+{
+	DISP_VIDEO1_CTRL,DISP_VIDEO1_ALPHA_CTRL,DISP_VIDEO1_X_POSITON,DISP_VIDEO1_Y_POSITON,DISP_VIDEO1_SRC_X_CROP,DISP_VIDEO1_SRC_Y_CROP,
+	DISP_VIDEO1_LAI_PARAM,DISP_VIDEO1_YV_RATIO,DISP_VIDEO1_YH_RATIO,DISP_VIDEO1_CV_RATIO,DISP_VIDEO1_CH_RATIO,DISP_VIDEO1_Y_NOLINE_D,
+	DISP_VIDEO1_C_NOLINE_D,DISP_VIDEO1_Y_NOLINE_K,DISP_VIDEO1_C_NOLINE_K,DISP_VIDEO1_HOR_PHASE,DISP_VIDEO1_VER_PHASE,
+	DISP_VIDEO1_CUR_YT_ADDR,DISP_VIDEO1_CUR_CT_ADDR,DISP_VIDEO1_CUR_YB_ADDR,DISP_VIDEO1_CUR_CB_ADDR,DISP_VIDEO1_PRE_YT_ADDR,
+	DISP_VIDEO1_PRE_CT_ADDR,DISP_VIDEO1_PRE_YB_ADDR,DISP_VIDEO1_PRE_CB_ADDR,DISP_VIDEO1_POS_YT_ADDR,DISP_VIDEO1_POS_CT_ADDR,
+	DISP_VIDEO1_POS_YB_ADDR,DISP_VIDEO1_POS_CB_ADDR,DISP_VIDEO1_PPR_YT_ADDR,DISP_VIDEO1_PPR_CT_ADDR,DISP_VIDEO1_PPR_YB_ADDR,
+	DISP_VIDEO1_PPR_CB_ADDR,DISP_VIDEO1_STORE_Y_ADDR,DISP_VIDEO1_STORE_C_ADDR,DISP_VIDEO1_SRC_CTRL,DISP_VIDEO1_COEFF_UP,
+	DISP_VIDEO1_COEFF_ADDR,DISP_VIDEO1_F2F_START,DISP_VIDEO1_STA_F2F,DISP_VIDEO1_STA_DISP_NUM
+};
+
+static int dfreg_video1[9] =
+{
+	DISP_VIDEO2_CTRL,DISP_VIDEO2_X_POSITON,DISP_VIDEO2_Y_POSITON,DISP_VIDEO2_YT_ADDR,DISP_VIDEO2_CT_ADDR,DISP_VIDEO2_YB_ADDR,
+	DISP_VIDEO2_CB_ADDR,DISP_VIDEO2_SRC_CTRL,DISP_VIDEO2_STA_DISP_NUM
+};
+
+static int dfreg_video2[33] =
+{
+	DISP_VIDEO3_CTRL,DISP_VIDEO3_X_POSITON,DISP_VIDEO3_Y_POSITON,DISP_VIDEO3_SRC_X_CROP,DISP_VIDEO3_SRC_Y_CROP,DISP_VIDEO3_YV_RATIO,
+	DISP_VIDEO3_YH_RATIO,DISP_VIDEO3_CV_RATIO,DISP_VIDEO3_CH_RATIO,DISP_VIDEO3_Y_NOLINE_D,DISP_VIDEO3_C_NOLINE_D,
+	DISP_VIDEO3_Y_NOLINE_K,DISP_VIDEO3_C_NOLINE_K,DISP_VIDEO3_HOR_PHASE,DISP_VIDEO3_VER_PHASE,DISP_VIDEO3_YT_ADDR,
+	DISP_VIDEO3_CT_ADDR,DISP_VIDEO3_YB_ADDR,DISP_VIDEO3_CB_ADDR,DISP_VIDEO3_SRC_CTRL,DISP_VIDEO3_STA_DISP_NUM
+};
+#endif
+
+
+static  df_out_if_timing outputFormatInfo[] =
+{
+	//                 Frequency IsHD VSyncPol  HSyncPol   HTol   HActive HSyncFP HSyncWidth HSyncBP   VTol  VActline VSyncFP VSyncWidth VSyncBP VidType Vidrptr 
+	//(KHZ)   
+	{ 1,1280, 720,60, 74250,    1,  0,         0,       1650,  1280,    110,      40,      220,      750,   720,      5,       5,        20,   0,      0, 0,      0, 0,0, DISP_YUV_720P_60FPS,         "DISP_YUV_720P_60FPS"        },
+	{ 1,1920,1080,30, 74250,    1,  0,         0,       2200,  1920,     88,      44,      148,     1125,   1080,     2,       5,        15,    0,      0,1,      0, 0,0, DISP_YUV_1080I_30FPS,        "DISP_YUV_1080I_30FPS"       },
+	{ 1, 720, 480,60, 27000,    0,  1,         1,        858,   720,     16,      62,       60,      525,   480,      9,       6,        30,   0,      0, 0,      0, 0,0, DISP_YUV_480P,               "DISP_YUV_480P"              },
+	{ 1, 720, 480,30, 27000,    0,  1,         1,       1716,  1440,     38,     124,      114,      525,   480,      4,       3,        15,    0,      0,1,      1, 1,0, DISP_YUV_NTSC,               "DISP_YUV_NTSC"              },
+	{ 1,1280, 720,50, 74250,    1,  0,         0,       1980,  1280,    440,      40,      220,      750,   720,      5,       5,        20,    0,      0,0,      0, 0,0, DISP_YUV_720P_50FPS,         "DISP_YUV_720P_50FPS"        },
+	{ 1,1920,1080,25, 74250,    1,  0,         0,       2640,  1920,    528,      44,      148,     1125,   1080,     2,       5,        15,    0,      0,1,      0, 0,0, DISP_YUV_1080I_25FPS,        "DISP_YUV_1080I_25FPS"       },
+	{ 1, 720, 576,50, 27000,    0,  1,         1,        864,   720,     12,      64,       68,      625,   576,      5,       5,        39,    0,      0,0,      0, 0,0, DISP_YUV_576P,               "DISP_YUV_576P"              },
+	{ 1, 720, 576,25, 27000,    0,  1,         1,       1728,  1440,     24,     126,      138,      625,   576,      2,       3,        19,    0,      0,1,      1, 1,1, DISP_YUV_PAL,                "DISP_YUV_PAL"               },
+	{ 1,1920,1080,60,148500,    1,  0,         0,       2200,  1920,     88,      44,      148,     1125,  1080,      4,       5,        36,    0,      0,0,      0, 0,0, DISP_YUV_1080P_60FPS,        "DISP_YUV_1080P_60FPS"       },
+	{ 1,1920,1080,50,148500,    1,  0,         0,       2640,  1920,    528,      44,      148,     1125,  1080,      4,       5,        36,    0,      0,0,      0, 0,0, DISP_YUV_1080P_50FPS,        "DISP_YUV_1080P_50FPS"       },
+	{ 1,1920,1080,24, 74250,    1,  0,         0,       2750,  1920,    638,      44,      148,     1125,  1080,      4,       5,        36,    0,      0,0,      0, 0,0, DISP_YUV_1080P_24FPS,        "DISP_YUV_1080P_24FPS"       },
+	{ 1,1920,1080,25, 74250,    1,  0,         0,       2640,  1920,    528,      44,      148,     1125,  1080,      4,       5,        36,    0,      0,0,      0, 0,0, DISP_YUV_1080P_25FPS,        "DISP_YUV_1080P_25FPS"       },
+	{ 1,1920,1080,30, 74250,    1,  0,         0,       2200,  1920,     88,      44,      148,     1125,  1080,      4,       5,        36,    0,      0,0,      0, 0,0, DISP_YUV_1080P_30FPS,        "DISP_YUV_1080P_30FPS"       },
+	{ 1,1920,1080,25, 72000,    1,  1,         0,       2304,  1920,     32,     168,      184,     1250,  1080,     23,       5,        57,    0,      0,1,      0, 0,0, DISP_YUV_1080I_25FPS_AS,     "DISP_YUV_1080I_50FPS_F1"    },
+	{ 0, 640, 480,60, 25175,    0,  1,         1,        800,   640,     16,      96,       48,      525,   480,     10,       2,        33,    0,      0,      0,      0, 0,0, DISP_RGB_VGA_60FPS,          "DISP_RGB_VGA_60FPS"         },
+	{ 0, 800, 600,60, 40000,    0,  0,         0,       1056,   800,     40,     128,       88,      628,   600,      1,       4,        23,    0,      0,      0,      0, 0,0, DISP_RGB_SVGA_60FPS,         "DISP_RGB_SVGA_60FPS"        },
+	{ 0,1024, 768,60, 65000,    0,  1,         1,       1344,  1024,     24,     136,      160,      806,   768,      3,       6,        29,    0,      0,      0,      0, 0,0, DISP_RGB_XGA_60FPS,          "DISP_RGB_XGA_60FPS"         },
+	{ 0,1280,1024,60,108000,    1,  0,         0,       1688,  1280,     48,     112,      248,     1066,  1024,      1,       3,        38,    0,      0,      0,      0, 0,0, DISP_RGB_SXGA_60FPS,         "DISP_RGB_SXGA_60FPS"        },
+	{ 0,1600,1200,60,162000,    1,  0,         0,       2160,  1600,     64,     192,      304,     1250,  1200,      1,       3,        46,    0,      0,      0,      0, 0,0, DISP_RGB_UXGA_60FPS,         "DISP_RGB_UXGA_60FPS"        },
+	{ 0,1280, 720,60, 74375,    1,  0,         0,       1664,  1280,     56,     136,      192,      746,   720,      1,       3,        22,    0,      0,      0,      0, 0,0, DISP_RGB_720P_60FPS,         "DISP_RGB_720P_60FPS"        },
+	{ 1, 360, 288,50, 27000,    0,  1,         1,       1728,  1440,     24,     126,      138,      312,   288,      2,       3,        19,    0,      0,      0,      1, 0,0, DISP_1440x288P_50_M1,        "DISP_1440x288P_50_M1"       },
+	{ 1, 360, 288,50, 27000,    0,  1,         1,       1728,  1440,     24,     126,      138,      313,   288,      3,       3,        19,    0,      0,      0,      1, 0,0, DISP_1440x288P_50_M2,        "DISP_1440x288P_50_M2"       },
+	{ 1, 360, 288,50, 27000,    0,  1,         1,       1728,  1440,     24,     126,      138,      314,   288,      4,       3,        19,    0,      0,      0,      1, 0,0, DISP_1440x288P_50_M3,        "DISP_1440x288P_50_M3"       },
+	{ 1, 720, 576,25, 54000,    0,  1,         1,       3456,  2880,     48,     252,      276,      625,   576,      2,       3,        19,    0,      0,      1,      3, 0,1, DISP_2880x576I_50,           "DISP_2880x576I_50"          },
+	{ 1, 720, 288,50, 54000,    0,  1,         1,       3456,  2880,     48,     252,      276,      312,   288,      2,       3,        19,    0,      0,      0,      3, 0,0, DISP_2880x288P_50_M1,        "DISP_2880x288P_50_M1"       },
+	{ 1, 720, 288,50, 54000,    0,  1,         1,       3456,  2880,     48,     252,      276,      313,   288,      3,       3,        19,    0,      0,      0,      3, 0,0, DISP_2880x288P_50_M2,        "DISP_2880x288P_50_M2"       },
+	{ 1, 720, 288,50, 54000,    0,  1,         1,       3456,  2880,     48,     252,      276,      314,   288,      4,       3,        19,    0,      0,      0,      3, 0,0, DISP_2880x288P_50_M3,        "DISP_2880x288P_50_M3"       },
+	{ 1, 720, 576,50, 54000,    0,  1,         1,       1728,  1440,     24,     128,      136,      625,   576,      5,       5,        39,    0,      0,      0,      1, 0,0, DISP_1440x576P_50,           "DISP_1440x576P_50"          },
+	{ 1, 720, 240,60, 27000,    0,  1,         1,       1716,  1440,     38,     124,      114,      262,   240,      4,       3,        15,    0,      0,      0,      1, 0,0, DISP_1440x240P_60_M1,        "DISP_1440x240P_60_M1"       },
+	{ 1, 720, 240,60, 27000,    0,  1,         1,       1716,  1440,     38,     124,      114,      263,   240,      5,       3,        15,    0,      0,      0,      1, 0,0, DISP_1440x240P_60_M2,        "DISP_1440x240P_60_M2"       },
+	{ 1, 720, 480,30, 54000,    0,  1,         1,       3432,  2880,     76,     248,      228,      525,   480,      4,       3,        15,    0,      0,      1,      3, 0,0, DISP_2880x480I_60,           "DISP_2880x480I_60"          },
+	{ 1, 720, 240,60, 54000,    0,  1,         1,       3432,  2880,     76,     248,      228,      262,   240,      4,       3,        15,    0,      0,      0,      3, 0,0, DISP_2880x240P_60_M1,        "DISP_2880x240P_60_M1"       },
+	{ 1, 720, 240,60, 54000,    0,  1,         1,       3432,  2880,     76,     248,      228,      263,   240,      5,       3,        15,    0,      0,      0,      3, 0,0, DISP_2880x240P_60_M2,        "DISP_2880x240P_60_M2"       },
+	{ 1, 720, 480,60, 54000,    0,  1,         1,       1716,  1440,     32,     124,      120,      525,   480,      9,       6,        30,    0,      0,      0,      1, 0,0, DISP_1440x480P_60,           "DISP_1440x480P_60"          },
+	{ 0, 640, 480,60, 25175,    0,  1,         1,        800,   640,      8,      96,       40,      525,   480,     10,       2,        33,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_640x480_60,     "DISP_RGB_DMT_640x480_60"    },
+	{ 0, 640, 480,75, 31500,    0,  1,         1,        840,   640,     16,      64,      120,      500,   480,      1,       3,        16,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_640x480_75,     "DISP_RGB_DMT_640x480_75"    },
+	{ 0, 800, 600,60, 40000,    0,  0,         0,       1056,   800,     40,     128,       88,      628,   600,      1,       4,        23,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_800x600_60,     "DISP_RGB_DMT_800x600_60"    },
+	{ 0, 800, 600,75, 49500,    0,  0,         0,       1056,   800,     16,      80,      160,      625,   600,      1,       3,        21,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_800x600_75,     "DISP_RGB_DMT_800x600_75"    },
+	{ 0, 848, 480,60, 33750,    0,  0,         0,       1088,   848,     16,     112,      112,      517,   480,      6,       8,        23,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_848x480_60,     "DISP_RGB_DMT_848x480_60"    },
+	{ 0,1152, 864,75,108000,    1,  0,         0,       1600,  1152,     64,     128,      256,      900,   864,      1,       3,        32,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_1152x864_75,    "DISP_RGB_DMT_1152x864_75"   },
+	{ 0,1280, 768,60, 68250,    1,  1,         0,       1440,  1280,     48,      32,       80,      790,   768,      3,       7,        12,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_1280x768_60,    "DISP_RGB_DMT_1280x768_60"   },
+	{ 0,1280, 960,60,108000,    1,  0,         0,       1800,  1280,     96,     112,      312,     1000,   960,      1,       3,        36,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_1280x960_60,    "DISP_RGB_DMT_1280x960_60"   },
+	{ 0,1280,1024,60,108000,    1,  0,         0,       1688,  1280,     48,     112,      248,     1066,  1024,      1,       3,        38,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_1280x1024_60,   "DISP_RGB_DMT_1280x1024_60"  },
+	{ 0,1360, 768,60, 85500,    1,  0,         0,       1792,  1360,     64,     112,      256,      795,   768,      3,       6,        18,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_1360x768_60,    "DISP_RGB_DMT_1360x768_60"   },
+	{ 0,1440, 900,60,106500,    1,  0,         1,       1904,  1440,     80,     152,      232,      934,   900,      3,       6,        25,    0,      0,      0,      0, 0,0, DISP_RGB_DMT_1440x900_60,    "DISP_RGB_DMT_1440x900_60"   },
+	{ 0, 640, 480,75, 30625,    0,  0,         1,        816,   640,     24,      64,       88,      502,   480,      1,       3,        18,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_640x480_75,     "DISP_RGB_CVT_640x480_75"    },
+	{ 0, 800, 600,60, 38125,    0,  0,         1,       1024,   800,     32,      80,      112,      622,   600,      1,       3,        18,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_800x600_60,     "DISP_RGB_CVT_800x600_60"    },
+	{ 0, 800, 600,75, 48875,    0,  0,         1,       1040,   800,     40,      80,      120,      627,   600,      1,       3,        23,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_800x600_75,     "DISP_RGB_CVT_800x600_75"    },
+	{ 0,1024, 768,60, 64125,    1,  0,         1,       1344,  1024,     56,     112,      168,      802,   768,      1,       3,        30,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1024x768_60,    "DISP_RGB_CVT_1024x768_60"   },
+	{ 0,1280,1024,60,108875,    1,  0,         1,       1712,  1280,     80,     136,      216,     1060,  1024,      1,       3,        41,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1280x1024_60,   "DISP_RGB_CVT_1280x1024_60"  },
+	{ 0, 848, 480,60, 31500,    0,  0,         1,       1056,   848,     16,      88,      104,      497,   480,      1,       3,        13,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_848x480_60,     "DISP_RGB_CVT_848x480_60"    },
+	{ 0, 848, 480,75, 40875,    0,  0,         1,       1088,   848,     32,      88,      120,      502,   480,      1,       3,        18,   0,      0,      0,      0, 0,0, DISP_RGB_CVT_848x480_75,     "DISP_RGB_CVT_848x480_75"    },
+	{ 0,1024, 576,60, 46875,    1,  0,         1,       1312,  1024,     40,     104,      144,      597,   576,      1,       3,        17,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1024x576_60,    "DISP_RGB_CVT_1024x576_60"   },
+	{ 0,1024, 576,75, 60625,    1,  0,         1,       1344,  1024,     56,     104,      160,      602,   576,      1,       3,        22,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1024x576_75,    "DISP_RGB_CVT_1024x576_75"   },
+	{ 0,1280, 720,60, 74375,    1,  0,         1,       1664,  1280,     56,     136,      192,      746,   720,      1,       3,        22,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1280x720_60,    "DISP_RGB_CVT_1280x720_60"   },
+	{ 0,1280, 720,75, 95625,    1,  0,         1,       1696,  1280,     72,     136,      208,      752,   720,      1,       3,        28,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1280x720_75,    "DISP_RGB_CVT_1280x720_75"   },
+	{ 0, 640, 400,75, 25000,    0,  0,         1,        800,   640,     16,      64,       80,      418,   400,      1,       3,        14,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_640x400_75,     "DISP_RGB_CVT_640x400_75"    },
+	{ 0, 768, 480,60, 28625,    0,  0,         1,        960,   768,     16,      80,       96,      497,   480,      1,       3,        13,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_768x480_60,     "DISP_RGB_CVT_768x480_60"    },
+	{ 0, 768, 480,75, 37250,    0,  0,         1,        992,   768,     32,      80,      112,      502,   480,      1,       3,        18,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_768x480_75,     "DISP_RGB_CVT_768x480_75"    },
+	{ 0,1024, 640,60, 52750,    1,  0,         1,       1328,  1024,     48,     104,      152,      663,   640,      1,       3,        19,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1024x640_60,    "DISP_RGB_CVT_1024x640_60"   },
+	{ 0,1024, 640,75, 67375,    1,  0,         1,       1344,  1024,     56,     104,      160,      669,   640,      1,       3,        25,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1024x640_75,    "DISP_RGB_CVT_1024x640_75"   },
+	{ 0,1280, 800,75,107250,    1,  0,         1,       1712,  1280,     80,     136,      216,      835,   800,      1,       3,        31,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1280x800_75,    "DISP_RGB_CVT_1280x800_75"   },
+	{ 0, 800, 600,60, 34375,    0,  1,         0,        928,   800,     32,      32,       64,      618,   600,      1,       3,        14,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_800x600_RED,    "DISP_RGB_CVT_800x600_RED"   },
+	{ 0,1024, 768,60, 54500,    1,  1,         0,       1152,  1024,     32,      32,       64,      790,   768,      1,       3,        18,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1024x768_RED,   "DISP_RGB_CVT_1024x768_RED"  },
+	{ 0,1280, 960,60, 83375,    1,  1,         0,       1408,  1280,     32,      32,       64,      988,   960,      1,       3,        24,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1280x960_RED,   "DISP_RGB_CVT_1280x960_RED"  },
+	{ 0, 848, 480,60, 28875,    0,  1,         0,        976,   848,     32,      32,       64,      494,   480,      1,       3,        10,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_848x480_RED,    "DISP_RGB_CVT_848x480_RED"   },
+	{ 0,1024, 576,60, 40875,    1,  1,         0,       1152,  1024,     32,      32,       64,      593,   576,      1,       3,        13,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1024x576_RED,   "DISP_RGB_CVT_1024x576_RED"  },
+	{ 0,1280, 720,60, 62500,    1,  1,         0,       1408,  1280,     32,      32,       64,      741,   720,      1,       3,        17,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1280x720_RED,   "DISP_RGB_CVT_1280x720_RED"  },
+	{ 0,1600, 900,60, 96000,    1,  1,         0,       1728,  1600,     32,      32,       64,      926,   900,      1,       3,        22,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1600x900_RED,   "DISP_RGB_CVT_1600x900_RED"  },
+	{ 0, 768, 480,60, 26500,    0,  1,         0,        896,   768,     32,      32,       64,      494,   480,      1,       3,        10,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_768x480_RED,    "DISP_RGB_CVT_768x480_RED"   },
+	{ 0,1024, 640,60, 45500,    1,  1,         0,       1152,  1024,     32,      32,       64,      659,   640,      1,       3,        15,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1024x640_RED,   "DISP_RGB_CVT_1024x640_RED"  },
+	{ 0,1280, 800,60, 69500,    1,  1,         0,       1408,  1280,     32,      32,       64,      823,   800,      1,       3,        19,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1280x800_RED,   "DISP_RGB_CVT_1280x800_RED"  },
+	{ 0,1600,1000,60,106625,    1,  1,         0,       1728,  1600,     32,      32,       64,     1029,  1000,      1,       3,        25,    0,      0,      0,      0, 0,0, DISP_RGB_CVT_1600x1000_RED,  "DISP_RGB_CVT_1600x1000_RED" },
+	{ 1,  64, 64, 60, 11111,    0,  1,         1,        128,    64,     20,      10,       34,      128,    64,      1,       3,        60,    0,      0,      0,      0, 0,0, DISP_64x64,"DISP_64x64"},
+	{ 1,1366, 768,60, 85500,    1,  0,         0,       1792,  1366,     70,      143,      213,     798,   768,      3,       3,        24,    0,      0,      0,      0, 0,0, DISP_VGA_1366x768,"DISP_VGA_1366x768"},
+	{ 1, 720, 480,60, 54000,    0,  1,         1,        858,   720,     16,      62,       60,      525,   480,      9,       6,        30,    1,     45,      0,      0, 0,0, DISP_YUV_480P_3D,               "DISP_YUV_480P_3D"              },
+	//{ 1, 720, 480,30, 54000,    0,  1,         1,       1716,  1440,     38,     124,      114,      525,   480,      4,       3,        15,    1,      23,      1,      1, 1,0, DISP_YUV_NTSC_3D,               "DISP_YUV_NTSC_3D"              },
+	{ 1, 720, 480,30, 54000,    0,  1,         1,       858,   720,     16,      62,       60,      525,   480,      4,       3,        15,    1,      23,      1,      1, 1,0, DISP_YUV_NTSC_3D,               "DISP_YUV_NTSC_3D"              },
+	{ 1, 720, 576,50, 54000,    0,  1,         1,        864,   720,     12,      64,       68,      625,   576,      5,       5,        39,    1,      49,      0,      0, 0,0, DISP_YUV_576P_3D,               "DISP_YUV_576P_3D"              },
+	{ 1, 720, 576,25, 54000,    0,  1,         1,       1728,  1440,     24,     126,      138,      625,   576,      2,       3,        19,    1,      25,      1,      1, 1,1, DISP_YUV_PAL_3D,                "DISP_YUV_PAL_3D"               },
+	{ 1,1280, 720,60, 74250,    1,  0,         0,       1650,  1280,    110,      40,      220,      750,   720,      5,       5,        20,   1,      30, 		0,      0, 0,0, DISP_YUV_720P_60FPS_3D,         "DISP_YUV_720P_60FPS_3D"        },
+	{ 1,1920,1080,30, 74250,    1,  0,         0,       2200,  1920,     88,      44,      148,     1125,  1080,      4,       5,        36,    1,      45,		0,      0, 0,0, DISP_YUV_1080P_30FPS_3D,        "DISP_YUV_1080P_30FPS_3D"       },
+	{ 1,1920,1080,30, 74250,    1,  0,         0,       2200,  1920,     88,      44,      148,     1125,   1080,     2,       5,        15,    1,      23,		1,      0, 0,0, DISP_YUV_1080I_30FPS_3D,        "DISP_YUV_1080I_30FPS_3D"       },
+	{ 1,1280, 720,50, 74250,    1,  0,         0,       1980,  1280,    440,      40,      220,      750,   720,      5,       5,        20,    1,      30,		0,      0, 0,0, DISP_YUV_720P_50FPS_3D,         "DISP_YUV_720P_50FPS_3D"        },
+	{ 1,1920,1080,24, 74250,    1,  0,         0,       2750,  1920,    638,      44,      148,     1125,  1080,      4,       5,        36,    1,      45,		0,      0, 0,0, DISP_YUV_1080P_24FPS_3D,        "DISP_YUV_1080P_24FPS_3D"       },
+	{ 1,1920,1080,25, 74250,    1,  0,         0,       2640,  1920,    528,      44,      148,     1125,  1080,      4,       5,        36,    1,      45,		0,      0, 0,0, DISP_YUV_1080P_25FPS_3D,        "DISP_YUV_1080P_25FPS_3D"       },
+	{ 1,1280, 720,30, 74250,    1,  0,         0,       1650,  1280,    110,      40,      220,      750,   720,      5,       5,        20,   1,      30, 		0,      0, 0,0, DISP_YUV_720P_30FPS_3D,         "DISP_YUV_720P_30FPS_3D"        },
+	{ 1,1920,1080,30, 74250,    1,  0,         0,       2200,  1920,     88,      44,      148,     1125,  530,      4,       5,        36,    1,      20,		0,      0, 0,0, DISP_YUV_1080P_30FPS_3D_TEMP,        "DISP_YUV_1080P_30FPS_3D_TEMP"       },
+	{ 1,1920,1080,30, 74250,    1,  0,         0,       2200,  1920,     88,      44,      148,     500,   250*2,     4,       5,        36,    1,      17,		1,      0, 0,0, DISP_YUV_1080I_30FPS_3D_TEMP,        "DISP_YUV_1080I_30FPS_3D_TEMP"       },
+	{ 0, 640, 480,60, 25175,	0,	1,		   1,		 800,	640,	 16,	  96,		48, 	 525,	480,	 10,	   2,		 33,	0,		0,		0,		0, 0,0, DISP_RGB_VGA_59P94FPS,			"DISP_RGB_VGA_59P94FPS" 		},
+	{ 0,1600,1200,60,162000,	1,	0,		   0,		2160,  1600,	 64,	 192,	   304, 	1250,	1200,	  1,	   3,		 46,	0,		0,		0,		0, 0,0, DISP_1600x1200_60FPS,		   "DISP_1600x1200_60FPS"		  }
+	//              Frequency IsHD VSyncPol  HSyncPol   HTol   HActive HSyncFP HSyncWidth HSyncBP   VTol  VActline VSyncFP VSyncWidth VSyncBP 3dEn 	VactSpace 	VidType 	Vidrptr
+};
+
+
+df_reg_para dfreg;
+
+DF_OUTPUT_CONFIG_t df_output_config = {
+	.gfx_output = {0,0},
+	.vid_output = {0,1,0},
+	.output_mode = {DF_OUTPUT_YPBPR, DF_OUTPUT_YPBPR},
+};
+
+static int tve_2_df[] = {
+	DISP_YUV_PAL,
+	DISP_YUV_NTSC,
+	DISP_YUV_576P,
+	DISP_YUV_480P,
+	DISP_YUV_720P_50FPS,
+	DISP_YUV_720P_60FPS,
+	DISP_YUV_1080I_25FPS,
+	DISP_YUV_1080I_30FPS,
+
+	DISP_YUV_PAL,
+	DISP_YUV_NTSC,
+	DISP_YUV_PAL,
+	DISP_YUV_PAL,
+	DISP_YUV_1080P_24FPS,
+	DISP_YUV_1080P_25FPS,
+	DISP_YUV_1080P_30FPS,
+	DISP_YUV_1080P_50FPS,
+	DISP_YUV_1080P_60FPS,
+
+	DISP_YUV_PAL,
+	DISP_YUV_NTSC,
+	DISP_YUV_NTSC,
+	DISP_YUV_NTSC,
+	DISP_YUV_576P,
+	DISP_YUV_480P,
+	DISP_YUV_480P,
+	DISP_YUV_480P,
+	DISP_YUV_720P_60FPS,
+	DISP_YUV_1080I_30FPS,
+	DISP_YUV_1080P_24FPS,
+	DISP_YUV_1080P_60FPS,
+
+	DISP_YUV_720P_60FPS_3D,
+	DISP_YUV_720P_60FPS_3D,
+	DISP_YUV_720P_50FPS_3D,
+	DISP_YUV_1080P_24FPS_3D,
+	DISP_YUV_1080P_24FPS_3D,
+
+	DISP_YUV_1080I_25FPS,
+	DISP_YUV_1080I_30FPS,
+	DISP_YUV_1080I_30FPS,
+
+	DISP_YUV_720P_50FPS,
+	DISP_YUV_720P_60FPS,
+	DISP_YUV_720P_60FPS,
+	DISP_YUV_1080P_24FPS,
+	DISP_YUV_1080P_24FPS,
+
+	DISP_RGB_VGA_60FPS,
+	DISP_RGB_CVT_800x600_60,
+	DISP_RGB_XGA_60FPS,
+	DISP_RGB_CVT_1280x720_60,
+	DISP_RGB_DMT_800x600_60,
+	DISP_RGB_DMT_1440x900_60,
+	DISP_RGB_DMT_1280x1024_60,
+	DISP_RGB_DMT_1360x768_60,
+	DISP_YUV_1080P_30FPS,
+	DISP_YUV_1080P_60FPS,
+	DISP_YUV_1080I_30FPS,
+	DISP_VGA_1366x768,
+	DISP_RGB_VGA_59P94FPS,
+	DISP_1600x1200_60FPS,
+};
+#if 0
+static int tve_2_clock[] = {
+	_YUV_PAL,
+	_YUV_NTSC,
+	_YUV_576P_50Hz,
+	_YUV_480P_60Hz,
+	_YUV_720P_50Hz,
+	_YUV_720P_60Hz,
+	_YUV_1080I_50Hz,
+	_YUV_1080I_60Hz,
+
+	_YUV_PAL,
+	_YUV_NTSC,
+	_YUV_PAL,
+	_YUV_PAL,
+	_YUV_1080P_24Hz,
+	_YUV_1080P_25Hz,
+	_YUV_1080P_30Hz,
+	_YUV_1080P_50Hz,
+	_YUV_1080P_60Hz,
+
+	_RGB_DMT_640x480_60Hz,
+	_RGB_DMT_1024x768_60Hz,
+	_RGB_DMT_1440x900_60Hz,
+	_RGB_DMT_1280x1024_60Hz,
+	_RGB_DMT_1360x768_60Hz,
+	_YUV_1080P_30Hz,
+	_YUV_1080P_60Hz,
+	_YUV_1080I_60Hz,
+};
+#endif
+enum _HDMI_VIDEO_TIMING_
+{
+	HDMI_NONE_STD_VID_FORMAT       =0,
+	HDMI_V640x480p_60Hz            =1,
+	HDMI_V720x480p_60Hz_4x3        =2,
+	HDMI_V720x480p_60Hz_16x9       =3,
+	HDMI_V720x480i_60Hz_4x3        =4,
+	HDMI_V720x480i_60Hz_16x9       =5,
+	HDMI_V720x576i_50Hz_4x3        =6,
+	HDMI_V720x576i_50Hz_16x9       =7,
+	HDMI_V720x576p_50Hz_4x3        =8,
+	HDMI_V720x576p_50Hz_16x9       =9,
+	HDMI_V1280x720p_50Hz           =10,
+	HDMI_V1280x720p_60Hz           =11,
+	HDMI_V1920x1080i_50Hz          =12,
+	HDMI_V1920x1080i_60Hz          =13,
+	HDMI_V1920x1080p_50Hz          =14,
+	HDMI_V1920x1080p_60Hz          =15,
+	HDMI_V1920x1080p_24Hz          =16,
+
+	HDMI_V800x600p_60Hz		=17,
+	HDMI_V1024x768p_60Hz		= 18,
+	HDMI_V1280x720p_RGB_60Hz           =19,
+	HDMI_V800x480p_60Hz		=20,
+	HDMI_V1440x900p_60Hz		=21,
+	HDMI_V1280x1024p_60Hz	=22,
+	HDMI_V1360x768p_60Hz		=23,
+	HDMI_V1920x1080p_RGB_30Hz          =24,
+	HDMI_V1920x1080p_RGB_60Hz          =25,
+	HDMI_V1920x1080i_RGB_30Hz          =26,
+	HDMI_V1366x768p_60Hz		=27,
+};
+
+enum _HDMI_VIDEO_ASPECT_
+{
+	HDMI_ASPECT_4x3,
+	HDMI_ASPECT_16x9,
+};
+#if 0
+static int tve_2_hdmi[][2] = {
+	{HDMI_V720x576i_50Hz_4x3,HDMI_ASPECT_4x3},
+	{HDMI_V720x480i_60Hz_4x3,HDMI_ASPECT_4x3},
+	{HDMI_V720x576p_50Hz_4x3,HDMI_ASPECT_4x3},
+	{HDMI_V720x480p_60Hz_4x3,HDMI_ASPECT_4x3},
+	{HDMI_V1280x720p_50Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1280x720p_60Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1920x1080i_50Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1920x1080i_60Hz,HDMI_ASPECT_16x9},
+
+	{HDMI_V720x576i_50Hz_4x3,HDMI_ASPECT_4x3},
+	{HDMI_V720x480i_60Hz_4x3,HDMI_ASPECT_4x3},
+	{HDMI_V720x576i_50Hz_4x3,HDMI_ASPECT_4x3},
+	{HDMI_V720x576i_50Hz_4x3,HDMI_ASPECT_4x3},
+
+	{HDMI_V1920x1080p_24Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1920x1080p_50Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1920x1080p_60Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1920x1080p_50Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1920x1080p_60Hz,HDMI_ASPECT_16x9},
+
+	{HDMI_V640x480p_60Hz,HDMI_ASPECT_4x3},
+
+#if 1
+	{HDMI_V800x600p_60Hz,HDMI_ASPECT_4x3},
+	{HDMI_V1024x768p_60Hz,HDMI_ASPECT_4x3},
+	{HDMI_V1280x720p_RGB_60Hz,HDMI_ASPECT_16x9},
+	{HDMI_V800x480p_60Hz,-1},
+	{HDMI_V1440x900p_60Hz,-1},
+	{HDMI_V1280x1024p_60Hz,HDMI_ASPECT_4x3},
+	{HDMI_V1360x768p_60Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1920x1080p_RGB_30Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1920x1080p_RGB_60Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1920x1080i_RGB_30Hz,HDMI_ASPECT_16x9},
+	{HDMI_V1366x768p_60Hz,HDMI_ASPECT_16x9},
+#endif
+};
+#endif
+void __df_update_start(void)
+{
+	df_write(dfreg_ctrl[0], 1);
+	df_write(dfreg_ctrl[2], 1);
+}
+
+void __df_update_end(void)
+{
+	df_write(dfreg_ctrl[0], 0);
+	df_write(dfreg_ctrl[2], 0);
+}
+
+void __df_update_outif_start(void)
+{
+	df_write(dfreg_ctrl[1], 1);
+}
+
+void __df_update_outif_end(void)
+{
+	df_write(dfreg_ctrl[1], 0);
+}
+
+void __update_vid_handshake_start(void)
+{
+	int wait_times = 10;
+
+	do{
+		df_write(VPP_REG_GLB_CTRL_CPU_WQ,1);
+		wait_times--;
+		mdelay(10);
+		if (wait_times <= 0){
+			printk("%s : %s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
+			return;
+		}
+	}while((df_read(VPP_REG_GLB_CTRL_HAND_STATUS)&0x03)!=0x01);
+}
+
+void __update_vid_handshake_finish(void)
+{
+	df_write(VPP_REG_GLB_CTRL_CPU_WQ,0);
+}
+
+void DFSetOutIFVideoFmt(int OutIFId, DF_VIDEO_FORMAT Format, int En)
+{
+	//For Safety Format Switching It's better Disable the output clk First
+	df_outif_reg *OutIFReg= NULL;
+
+	OutIFId = OutIFId & 0x1;
+	OutIFReg = &dfreg.OutIF[OutIFId];
+
+	OutIFReg->reg_tg_ctrl.val = df_read(dfreg_outif[OutIFId][0]);
+	OutIFReg->reg_tg_x_size.val = df_read(dfreg_outif[OutIFId][1]);
+	OutIFReg->reg_tg_y_size.val = df_read(dfreg_outif[OutIFId][2]);
+	OutIFReg->reg_tg_hsync.val = df_read(dfreg_outif[OutIFId][3]);
+	OutIFReg->reg_tg_vsync.val = df_read(dfreg_outif[OutIFId][4]);
+
+	OutIFReg->reg_tg_ctrl.bits.tg_en=En;
+	OutIFReg->reg_tg_ctrl.bits.tg_is_hd=outputFormatInfo[Format].mIsHD&0x01;
+	OutIFReg->reg_tg_ctrl.bits.tg_is_interlaced=0x01&outputFormatInfo[Format].mVidType&0x01;
+	OutIFReg->reg_tg_ctrl.bits.tg_is_pal=outputFormatInfo[Format].mPALFmt&0x01;
+	OutIFReg->reg_tg_ctrl.bits.tg_dither_mode=0;
+	OutIFReg->reg_tg_ctrl.bits.tg_hsync_pol=outputFormatInfo[Format].mHSyncPol&0x01;
+	OutIFReg->reg_tg_ctrl.bits.tg_vsync_pol=outputFormatInfo[Format].mVSyncPol&0x01;
+	OutIFReg->reg_tg_ctrl.bits.tg_dither_ena=1;
+	OutIFReg->reg_tg_ctrl.bits.tg_3d_act_space=outputFormatInfo[Format].m3dVactSpace&0xff;
+	OutIFReg->reg_tg_ctrl.bits.tg_3d_en=outputFormatInfo[Format].m3dEn&0x01;
+
+	OutIFReg->reg_tg_hsync.bits.tg_hsync_front_porch=outputFormatInfo[Format].mHSyncFP&0x3ff;
+	OutIFReg->reg_tg_hsync.bits.tg_hsync_width=outputFormatInfo[Format].mHSyncWidth&0x3ff;
+	OutIFReg->reg_tg_hsync.bits.tg_hsync_back_porch=outputFormatInfo[Format].mHSyncBP&0x3ff;
+
+	OutIFReg->reg_tg_vsync.bits.tg_vsync_front_porch=outputFormatInfo[Format].mVSyncFP&0xff;
+	OutIFReg->reg_tg_vsync.bits.tg_vsync_width=outputFormatInfo[Format].mVSyncWidth&0xff;
+	OutIFReg->reg_tg_vsync.bits.tg_vsync_back_porch=outputFormatInfo[Format].mVSyncBP&0xff;
+
+
+	OutIFReg->reg_tg_x_size.bits.tg_htotal=outputFormatInfo[Format].mHRes&0x1fff;
+	OutIFReg->reg_tg_x_size.bits.tg_hactive_width=outputFormatInfo[Format].mHActive&0xfff;
+	OutIFReg->reg_tg_y_size.bits.tg_vtotal=outputFormatInfo[Format].mVRes&0x1fff;
+	OutIFReg->reg_tg_y_size.bits.tg_vactive_height= outputFormatInfo[Format].mVActline&0xfff;
+
+	if(outputFormatInfo[Format].mIsYUVorRGB){
+		OutIFReg->reg_tg_vga_level.bits.tg_vga_black_level=0;
+		OutIFReg->reg_tg_vga_level.bits.tg_vga_white_level=1023;
+	}
+	else{
+		OutIFReg->reg_tg_vga_level.bits.tg_vga_black_level=252;
+		OutIFReg->reg_tg_vga_level.bits.tg_vga_white_level=800;
+	}
+
+	OutIFReg->reg_tg_sta_line.bits.tg_v_start_line_num=6;
+
+	df_write(dfreg_outif[OutIFId][1], dfreg.OutIF[OutIFId].reg_tg_x_size.val);
+	df_write(dfreg_outif[OutIFId][2], dfreg.OutIF[OutIFId].reg_tg_y_size.val);
+	df_write(dfreg_outif[OutIFId][3], dfreg.OutIF[OutIFId].reg_tg_hsync.val);
+	df_write(dfreg_outif[OutIFId][4], dfreg.OutIF[OutIFId].reg_tg_vsync.val);
+	df_write(dfreg_outif[OutIFId][5], dfreg.OutIF[OutIFId].reg_tg_vga_level.val);
+	df_write(dfreg_outif[OutIFId][6], dfreg.OutIF[OutIFId].reg_tg_sta_line.val);
+	df_write(dfreg_outif[OutIFId][0], dfreg.OutIF[OutIFId].reg_tg_ctrl.val);
+	return;
+}
+
+/*void DFOutIFEna(int OutIFId, int IsEna)
+  {
+  df_outif_reg *OutIFReg= NULL;
+
+  OutIFId = OutIFId & 0x1;
+  OutIFReg = &dfreg.OutIF[OutIFId];
+  OutIFReg->df_outif_control_reg.val = df_read(dfreg_outif[OutIFId][0]);
+
+  OutIFReg->df_outif_control_reg.bits.iDispEn = IsEna;
+
+  df_write(dfreg_outif[OutIFId][0], OutIFReg->df_outif_control_reg.val);
+
+  return;
+  }*/
+
+void DFSetZOrder(int OutIFId, int Gfx1ZOrder, int Gfx2ZOrder, int Video1ZOrder, int Video2ZOrder)
+{
+	df_compositor_reg *Reg= NULL;
+
+	Reg = &dfreg.Comp;
+	Reg->reg_comp_b2_z_order.val = df_read(dfreg_comp[1]);
+
+	Reg->reg_comp_b2_z_order.bits.blending2_gfx1_z_order   = Gfx1ZOrder;
+	Reg->reg_comp_b2_z_order.bits.blending2_gfx1_z_order   = Gfx2ZOrder;
+	Reg->reg_comp_b2_z_order.bits.blending2_video1_z_order = Video1ZOrder;
+	Reg->reg_comp_b2_z_order.bits.blending2_video2_z_order = Video2ZOrder;
+
+	df_write(dfreg_comp[1], Reg->reg_comp_b2_z_order.val);
+	return;
+}
+
+void DFSetBackGroud(int OutIFId, unsigned char BGY, unsigned char BGU, unsigned char BGV)
+{
+	df_compositor_reg *Reg= NULL;
+
+	Reg = &dfreg.Comp;
+	Reg->reg_comp_b2_back_ground.val = df_read(dfreg_comp[0]);
+
+	Reg->reg_comp_b2_back_ground.bits.blending2_bg_y = BGY<<2;
+	Reg->reg_comp_b2_back_ground.bits.blending2_bg_u = BGU<<2;
+	Reg->reg_comp_b2_back_ground.bits.blending2_bg_v = BGV<<2;
+
+	df_write(dfreg_comp[0], Reg->reg_comp_b2_back_ground.val);
+	return;
+}
+
+void DFGfxEna(int GfxId, int IsEna, int IsRGB2YUVEna)
+{
+	df_gfx_reg *Reg= NULL;
+
+	GfxId   = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+
+	Reg->reg_gfx_ui_ctrl.val = df_read(dfreg_gfx[GfxId][0]);
+
+	if(DF_OUTPUT_VGA == df_output_config.output_mode[df_output_config.gfx_output[GfxId]]){
+		IsRGB2YUVEna = 0;
+	}
+	else{
+		IsRGB2YUVEna = 1;
+	}
+
+	if(IsEna)
+	{
+		Reg->reg_gfx_ui_ctrl.bits.gfx_ui_ena = (1 << df_output_config.gfx_output[GfxId]);
+		Reg->reg_gfx_ui_ctrl.bits.gfx_ui_yuv_conv_ena = IsRGB2YUVEna;
+	}
+	else
+	{
+		Reg->reg_gfx_ui_ctrl.bits.gfx_ui_ena = 0;
+	}
+
+	df_printf("layer_output.gfx_output[%d] = %d\n",GfxId,df_output_config.gfx_output[GfxId]);
+	df_printf("Reg->df_gfx_control_reg.bits.iGfxEna = %d\n",Reg->reg_gfx_ui_ctrl.bits.gfx_ui_ena);
+
+	df_write(dfreg_gfx[GfxId][0], Reg->reg_gfx_ui_ctrl.val);
+
+	return;
+}
+
+void DFGfxSetAlpha(int GfxId, unsigned short DefaultAlpha, unsigned short ARGB1555Alpha0, unsigned short ARGB1555Alpha1)
+{
+	df_gfx_reg *Reg= NULL;
+
+	GfxId   = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+
+	Reg->reg_gfx_ui_alpha_ctrl.val = df_read(dfreg_gfx[GfxId][1]);
+
+	Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_default_alpha   = DefaultAlpha & 0x3ff;
+	Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a0 = ARGB1555Alpha0 & 0x3ff;
+	Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a1 = ARGB1555Alpha1 & 0x3ff;
+
+	df_write(dfreg_gfx[GfxId][1], Reg->reg_gfx_ui_alpha_ctrl.val);
+	return;
+}
+
+void DFGfxGetAlpha(int GfxId, unsigned short *DefaultAlpha, unsigned short *ARGB1555Alpha0, unsigned short *ARGB1555Alpha1)
+{
+	df_gfx_reg *Reg= NULL;
+
+	GfxId   = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+
+
+	Reg->reg_gfx_ui_alpha_ctrl.val = df_read(dfreg_gfx[GfxId][2]);
+
+	*DefaultAlpha = Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_default_alpha;
+	*ARGB1555Alpha0 = Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a0;
+	*ARGB1555Alpha1 = Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a1;
+
+	return;
+}
+
+void DFGfxSetColorKey(int GfxId, unsigned char KeyRMin, unsigned char KeyRMax, unsigned char KeyGMin, unsigned char KeyGMax, unsigned char KeyBMin, unsigned char KeyBMax)
+{
+	df_gfx_reg *Reg= NULL;
+
+	GfxId   = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+
+	Reg->reg_gfx_ui_key_red.val = df_read(dfreg_gfx[GfxId][3]);
+	Reg->reg_gfx_ui_key_blue.val = df_read(dfreg_gfx[GfxId][4]);
+	Reg->reg_gfx_ui_key_green.val = df_read(dfreg_gfx[GfxId][5]);
+
+	Reg->reg_gfx_ui_key_red.bits.gfx_ui_r_min   = KeyRMin;
+	Reg->reg_gfx_ui_key_red.bits.gfx_ui_r_max   = KeyRMax;
+	Reg->reg_gfx_ui_key_blue.bits.gfx_ui_b_min  = KeyBMin;
+	Reg->reg_gfx_ui_key_blue.bits.gfx_ui_b_max  = KeyBMax;
+	Reg->reg_gfx_ui_key_green.bits.gfx_ui_g_min = KeyGMin;
+	Reg->reg_gfx_ui_key_green.bits.gfx_ui_g_max = KeyGMax;
+
+	df_write(dfreg_gfx[GfxId][3], Reg->reg_gfx_ui_key_red.val);
+	df_write(dfreg_gfx[GfxId][4], Reg->reg_gfx_ui_key_blue.val);
+	df_write(dfreg_gfx[GfxId][5], Reg->reg_gfx_ui_key_green.val);
+
+	return;
+}
+
+void DFGfxColorKeyEna(int GfxId,int IsEna)
+{df_gfx_reg*Reg = NULL;
+
+	GfxId = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+	Reg->reg_gfx_ui_ctrl.val = df_read(dfreg_gfx[GfxId][0]);
+
+	Reg->reg_gfx_ui_ctrl.bits.gfx_ui_color_keying_en = IsEna;
+
+	df_write(dfreg_gfx[GfxId][0], Reg->reg_gfx_ui_ctrl.val);
+
+	return;
+}
+
+
+void DFGfxOpaqueOnOff(int GfxId,int OnOff)
+{
+	df_gfx_reg*Reg = NULL;
+
+	GfxId = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+	Reg->reg_gfx_ui_ctrl.val = df_read(dfreg_gfx[GfxId][0]);
+
+	Reg->reg_gfx_ui_ctrl.bits.gfx_ui_opaque = OnOff;
+
+	df_write(dfreg_gfx[GfxId][0], Reg->reg_gfx_ui_ctrl.val);
+
+	return;
+}
+
+
+#define SCALOR_COEF_ADDR 0x0d000000
+void DFGfxScalorCoef(void)
+{
+
+	memcpy((char*)SCALOR_COEF_ADDR,cof3tap,sizeof(cof3tap));
+	memcpy((char*)(SCALOR_COEF_ADDR+0x2000),cof4tap,sizeof(cof4tap));
+	memcpy((char*)(SCALOR_COEF_ADDR+0x4000),cof6tap,sizeof(cof6tap));
+	df_write(dfreg_ctrl[9],(unsigned int)SCALOR_COEF_ADDR);
+	df_write(dfreg_ctrl[10],(unsigned int)(SCALOR_COEF_ADDR+0x2000));
+	df_write(dfreg_ctrl[11],(unsigned int)(SCALOR_COEF_ADDR+0x4000));
+	//df_write(dfreg_ctrl[9],(unsigned int)cof3tap);
+	//df_write(dfreg_ctrl[10],(unsigned int)cof4tap);
+	//df_write(dfreg_ctrl[11],(unsigned int)cof6tap);
+	df_printf("cof3tap=%x,cof4tap=%x,cof6tap=%x\n",(unsigned int)cof3tap,(unsigned int)cof4tap,(unsigned int)cof6tap);
+}
+
+
+//Analog Video
+typedef enum _DAC0_MODE_
+{
+	_dac0_rgb0 =0,
+	_dac0_rgb1 =1,
+	_dac0_tve0_ypbpr =2,
+	_dac0_tve0_cvbs_svideo =3,
+	_dac0_tve1_ypbpr =4,
+	_dac0_tve1_cvbs_svideo  =5,
+}DAC0_MODE;
+
+typedef enum _DAC1_MODE_
+{
+	_dac1_rgb1 = 0,
+	_dac1_tve1_ypbpr =1,
+	_dac1_tve1_cvbs_svideo  =2,
+}DAC1_MODE;
+
+
+
+#define REG_PINMUX_I2C		(CNC1900_PIN_MUX + 0x004)
+#define REG_PINMUX_DISP	(CNC1900_PIN_MUX + 0x014)
+#if 0
+void pinmux_set_dac1mode(DAC1_MODE Mode)
+{
+	unsigned short reg_val = 0;
+
+	reg_val = df_read16(REG_PINMUX_I2C);
+
+	switch(Mode)
+	{
+		case _dac1_tve0_ypbpr:
+			//			pinmux_base[REG_PINMUX_DISP>>1] &= (0<<8);
+			df_write16(REG_PINMUX_DISP, (0<<8));
+			break;
+		case _dac1_tve1_ypbpr:
+			//			pinmux_base[REG_PINMUX_DISP>>1] = (5<<8);
+			df_write16(REG_PINMUX_DISP, (5<<8));
+			break;
+		case _dac1_disp0_rgb:
+			//			pinmux_base[REG_PINMUX_DISP>>1] = (1<<8);
+			//			pinmux_base[REG_PINMUX_I2C>>1] |= (1<<1);
+			//			pinmux_base[REG_PINMUX_I2C>>1] |= (1<<2);
+			//			pinmux_base[REG_PINMUX_I2C>>1] |= (1<<3);
+			df_write16(REG_PINMUX_DISP, (1<<8));
+			df_write16(REG_PINMUX_I2C, reg_val |0xe);
+			break;
+		case _dac1_disp1_rgb:
+			//			pinmux_base[REG_PINMUX_DISP>>1] = (6<<8);
+			//			pinmux_base[REG_PINMUX_I2C>>1] |= (1<<1);
+			//			pinmux_base[REG_PINMUX_I2C>>1] |= (1<<2);
+			//			pinmux_base[REG_PINMUX_I2C>>1] &= ~(1<<3);
+			df_write16(REG_PINMUX_DISP, (6<<8));
+			df_write16(REG_PINMUX_I2C, reg_val |0x6);
+			break;
+		case _dac1_tve1_cvbs:
+			//			pinmux_base[REG_PINMUX_DISP>>1] = (4<<8);
+			df_write16(REG_PINMUX_DISP, reg_val & (4<<8));
+			break;
+	}
+
+	return;
+}
+#endif
+int pinmux_set_dac0mode(DAC0_MODE Mode)
+{
+
+	//reg_val = df_read(REG_PINMUX_I2C);
+	switch(Mode)
+	{
+		case _dac0_rgb0:
+			//pinmux_base[REG_PINMUX_DISP>>2] |= (1<<9);
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<10));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)| (1<<9));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)& (~(1<<10)));
+			break;
+		case _dac0_rgb1:
+			//pinmux_base[REG_PINMUX_DISP>>2] |= (1<<9);
+			//pinmux_base[REG_PINMUX_DISP>>2] |= (1<<10);	
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)| (1<<9));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)| (1<<10));
+			break;
+		case _dac0_tve0_ypbpr:
+			//pinmux_base[REG_PINMUX_DISP>>2] |= (1<<8);
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<9));
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<10));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)|(1<<8));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)&(~(1<<9)));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)& (~(1<<10)));
+			break;
+		case _dac0_tve0_cvbs_svideo:
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<8));
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<9));
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<10));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)&(~(1<<8)));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)&(~(1<<9)));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)&(~(1<<10)));
+			break;
+		case _dac0_tve1_ypbpr:
+			//pinmux_base[REG_PINMUX_DISP>>2] |= (1<<8);
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<9));
+			//pinmux_base[REG_PINMUX_DISP>>2] |= (1<<10);
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)|(1<<8));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)&(~(1<<9)));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)|(1<<10));
+			break;
+		case _dac0_tve1_cvbs_svideo:
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<8));
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<9));
+			//pinmux_base[REG_PINMUX_DISP>>2] |= (1<<10);
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)&(~(1<<8)));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)&(~(1<<9)));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)|(1<<10));
+			break;
+	}
+
+	return 0;
+}
+
+int pinmux_set_dac1mode(DAC1_MODE Mode)
+{
+	switch(Mode){
+		case _dac1_rgb1:
+			//pinmux_base[REG_PINMUX_DISP>>2] |= (1<<12);	
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)|(1<<12));
+			break;
+		case _dac1_tve1_ypbpr:
+			//pinmux_base[REG_PINMUX_DISP>>2] |= (1<<11);
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<12));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)|(1<<11));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)&(~(1<<12)));
+			break;
+		case _dac1_tve1_cvbs_svideo:
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<11));
+			//pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<12));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)& (~(1<<11)));
+			df_write(REG_PINMUX_DISP, df_read(REG_PINMUX_DISP)& (~(1<<12)));
+			break;
+	}
+
+	return 0;
+}
+
+
+extern unsigned int GFXLINEPITCHSIZE;
+extern unsigned int GFX2BASEADDRESS;//not use so far
+extern unsigned int screen_w,screen_h,picture_color_mode;
+
+unsigned int gfxid = 0;
+unsigned int UIStarted=0;
+unsigned int UiStarted(void)
+{
+	return UIStarted;
+}
+//unsigned char testbuffer[1280*720*4];
+static int	CS_LoadDisplay (DF_GFX_IMG* ColorImg)
+{
+
+	////////////////////////////////////////////////////////////
+	__df_update_start();
+
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.val = df_read(dfreg_gfx[gfxid][0]);
+	dfreg.Gfx[gfxid].reg_gfx_ui_buf_start.val = df_read(dfreg_gfx[gfxid][6]);
+	dfreg.Gfx[gfxid].reg_gfx_ui_line_pitch.val = df_read(dfreg_gfx[gfxid][7]);
+	dfreg.Gfx[gfxid].reg_gfx_ui_x_position.val = df_read(dfreg_gfx[gfxid][8]);
+	dfreg.Gfx[gfxid].reg_gfx_ui_y_position.val = df_read(dfreg_gfx[gfxid][9]);
+	DFGfxScalorCoef();
+
+	DFGfxEna(gfxid,1, 0);
+
+	__df_update_end();
+
+	__df_update_start();
+
+	DFGfxSetAlpha(gfxid, 0xff, 0, 0);
+
+	DFGfxSetColorKey(gfxid, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);
+	DFGfxColorKeyEna(gfxid, 1);
+	DFGfxOpaqueOnOff(gfxid, 0);
+
+	DFSetBackGroud(gfxid,0,128,128);
+
+
+	dfreg.Gfx[gfxid ].reg_gfx_ui_ctrl.bits.ui_tg1_en=1;
+
+	////////////////////test/////////////////////////
+	//memset(testbuffer,1280*720*4,0xff00ff00);
+	//dfreg.Gfx[gfxid].reg_gfx_ui_buf_start.val=(unsigned int)testbuffer;
+	dfreg.Gfx[gfxid].reg_gfx_ui_buf_start.val=ColorImg->StartAddress;
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_line_pitch.val = ColorImg->LinePitch;
+	dfreg.Gfx[gfxid ].reg_gfx_ui_ctrl.bits.gfx_ui_format=ColorImg->ColorFormat;//picture_color_mode;
+
+	df_printf("dfreg.Gfx[gfxid ].reg_gfx_ui_ctrl.bits.gfx_ui_format=%d\n",dfreg.Gfx[gfxid ].reg_gfx_ui_ctrl.bits.gfx_ui_format);
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_ena                       = 1;
+	// dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_format                    = UiFormat; // rgb32
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_endian                    = 0;
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_opaque                    = 1;
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_color_keying_en           = 0;
+	// dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_color_keying_en           = 1;
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_ena_premul                = 0;
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_af_sc_dis                 = 0;//scaler
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_antiflicker_en_a          = 1;
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_antiflicker_en_c          = 1;
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_ena_demul                 = 0;
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_yuv_conv_ena              = 1;
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.gfx_ui_bw_limit                  = 0;
+	dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.bits.ui_tg1_en                        = 1; // ui1,ui2 using tg1 switch
+
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_size.bits.gfx_ui_src_width                 = ColorImg->PixelWidth;//info->var.xres;//1920;//ui1_src_width ;
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_size.bits.gfx_ui_src_height                = ColorImg->PixelHeight;//info->var.yres;//1080;//ui1_src_height; 
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_alpha_ctrl.bits.gfx_ui_default_alpha       = 255;
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_buf_start_3d.bits.gfx_ui_buf_start_3d      = dfreg.Gfx[gfxid].reg_gfx_ui_buf_start.bits.gfx_ui_buf_start ;
+
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_x_position.bits.gfx_ui_dst_x_start         =0;// SrcDstParam.DesStartX;//ui1_dst_x_start; // 10;
+	dfreg.Gfx[gfxid].reg_gfx_ui_x_position.bits.gfx_ui_dst_x_end           = screen_w-1;//SrcDstParam.DesEndX;//ui1_dst_x_end  ; // 1024-10;
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_start         = 0;//SrcDstParam.DesStartY;//ui1_dst_y_start; // 10;
+	dfreg.Gfx[gfxid].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_end           = screen_h;//SrcDstParam.DesEndY;//ui1_dst_y_end  ; // 720-10;
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_a8.bits.gfx_ui_a8_r                        = 100;
+	dfreg.Gfx[gfxid].reg_gfx_ui_a8.bits.gfx_ui_a8_g                        = 100;
+	dfreg.Gfx[gfxid].reg_gfx_ui_a8.bits.gfx_ui_a8_b                        = 100;
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_phase.bits.gfx_ui_hphase                   = 0;
+	dfreg.Gfx[gfxid].reg_gfx_ui_phase.bits.gfx_ui_vphase                   = 32;
+
+	dfreg.Gfx[gfxid].reg_gfx_ui_coeff_gid.bits.gfx_ui_hcoeff_gid           = 0;
+	dfreg.Gfx[gfxid].reg_gfx_ui_coeff_gid.bits.gfx_ui_vcoeff_gid           = 0;
+
+	df_printf(" dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.val=%x\n", dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.val);
+	df_write((dfreg_gfx[gfxid][0]), dfreg.Gfx[gfxid].reg_gfx_ui_ctrl.val);
+	df_write((dfreg_gfx[gfxid][1]), dfreg.Gfx[gfxid].reg_gfx_ui_alpha_ctrl.val);
+	df_write((dfreg_gfx[gfxid][2]), dfreg.Gfx[gfxid].reg_gfx_ui_size.val);
+	df_write((dfreg_gfx[gfxid][3]), dfreg.Gfx[gfxid].reg_gfx_ui_key_red.val);
+	df_write((dfreg_gfx[gfxid][4]), dfreg.Gfx[gfxid].reg_gfx_ui_key_blue.val);
+	df_write((dfreg_gfx[gfxid][5]), dfreg.Gfx[gfxid].reg_gfx_ui_key_green.val);
+	df_write((dfreg_gfx[gfxid][6]), dfreg.Gfx[gfxid].reg_gfx_ui_buf_start.val);
+	df_write((dfreg_gfx[gfxid][7]), dfreg.Gfx[gfxid].reg_gfx_ui_line_pitch.val);
+	df_write((dfreg_gfx[gfxid][8]), dfreg.Gfx[gfxid].reg_gfx_ui_x_position.val);
+	df_write((dfreg_gfx[gfxid][9]), dfreg.Gfx[gfxid].reg_gfx_ui_y_position.val);
+	df_write((dfreg_gfx[gfxid][10]), dfreg.Gfx[gfxid].reg_gfx_ui_buf_start_3d.val);
+	df_write((dfreg_gfx[gfxid][11]), dfreg.Gfx[gfxid].reg_gfx_ui_a8.val);
+	df_write((dfreg_gfx[gfxid][12]), dfreg.Gfx[gfxid].reg_gfx_ui_phase.val);
+	df_write((dfreg_gfx[gfxid][13]), dfreg.Gfx[gfxid].reg_gfx_ui_coeff_gid.val);
+
+	DFGfxEna(gfxid, 1, 0);
+	/*dfreg.Gfx[gfxid].reg_gfx_ui_coeff_gid.bits.gfx_ui_hcoeff_gid           = 0;
+	  dfreg.Gfx[gfxid].reg_gfx_ui_coeff_gid.bits.gfx_ui_vcoeff_gid           = 0;
+	  df_write((dfreg_gfx[gfxid][13]), dfreg.Gfx[gfxid].reg_gfx_ui_coeff_gid.val);*/
+	__df_update_end();
+
+	UIStarted=1;
+
+	{
+		int i;
+		for (i=0;i<13;i++)
+			df_printf("ui reg %x,  val=%x\n",i*4,df_read(dfreg_gfx[gfxid][i]));
+	}
+	return 0;
+}
+
+#ifdef CONFIG_TVOUT_CVBS
+#define VIDEO2PITCH 2048
+#if 0
+void DFVideoEna(int VideoId, int IsEna, int v_w, int v_h, unsigned int yuv_addr)
+{
+	df_video1_reg *reg_video1 = NULL;
+	df_video2_reg *reg_video2 = NULL;
+	df_video3_reg *reg_video3 = NULL;
+
+	switch(VideoId)
+	{
+		case 0:
+			reg_video1 = &dfreg.Video1;
+			reg_video1->df_video_control_reg.val = df_read(dfreg_video0[0]);
+			reg_video1->df_video_control_reg.bits.iVideoEnable = IsEna;
+			df_write(dfreg_video0[0], reg_video1->df_video_control_reg.val);
+			break;
+		case 1:
+			reg_video2 = &dfreg.Video2;
+			reg_video2->df_video_control_reg.val = df_read(dfreg_video1[0]);
+			reg_video2->df_video_control_reg.bits.iVideoEnable = IsEna;
+			reg_video2->df_video_x_position_reg.val = 0x02d00000;
+			reg_video2->df_video_y_position_reg.val = 0x02400000;
+			reg_video2->df_video_yt_addr_reg.val = yuv_addr;
+			reg_video2->df_video_ct_addr_reg.val = yuv_addr + (VIDEO2PITCH * v_h);
+			reg_video2->df_video_yb_addr_reg.val = yuv_addr + 0x800;
+			reg_video2->df_video_cb_addr_reg.val = yuv_addr + (VIDEO2PITCH * v_h) + 0x800;
+			reg_video2->df_video_src_ctrl_reg.val = 0x00000100;	
+			df_write(dfreg_video1[1], reg_video2->df_video_x_position_reg.val);
+			df_write(dfreg_video1[2], reg_video2->df_video_y_position_reg.val);
+			df_write(dfreg_video1[3], reg_video2->df_video_yt_addr_reg.val);
+			df_write(dfreg_video1[4], reg_video2->df_video_ct_addr_reg.val);
+			df_write(dfreg_video1[5], reg_video2->df_video_yb_addr_reg.val);
+			df_write(dfreg_video1[6], reg_video2->df_video_cb_addr_reg.val);
+			df_write(dfreg_video1[7], reg_video2->df_video_src_ctrl_reg.val);
+			df_write(dfreg_video1[0], reg_video2->df_video_control_reg.val);
+			break;
+		case 2:
+			reg_video3 = &dfreg.Video3;
+			reg_video3->df_video_control_reg.val = df_read(dfreg_video2[0]);
+			reg_video3->df_video_control_reg.bits.iVideoEnable = IsEna;
+			df_write(dfreg_video2[0], reg_video3->df_video_control_reg.val);
+			break;
+		default:
+			break;
+	}
+
+	return;
+}
+
+
+void sdoutput(TVOUT_MODE mode, unsigned int addr)
+{
+	TVOUT_MODE tve1_mode;
+	int cvbs_w = 720, cvbs_h;
+
+	switch (mode){
+		case TVOUT_MODE_SECAM:
+			tve1_mode = TVOUT_MODE_SECAM;
+			cvbs_h = 576;
+			break;
+		case TVOUT_MODE_PAL_CN:
+			tve1_mode = TVOUT_MODE_PAL_CN;
+			cvbs_h = 576;
+			break;
+		case TVOUT_MODE_PAL_N:
+			tve1_mode = TVOUT_MODE_PAL_N;
+			cvbs_h = 576;
+			break;
+		case TVOUT_MODE_PAL_M:
+			tve1_mode = TVOUT_MODE_PAL_M;
+			cvbs_h = 480;
+			break;
+		case TVOUT_MODE_576I:
+		case TVOUT_MODE_576P:
+		case TVOUT_MODE_720P50:
+		case TVOUT_MODE_1080I25:
+		case TVOUT_MODE_1080P25:
+		case TVOUT_MODE_1080P50:
+			tve1_mode = TVOUT_MODE_576I;
+			cvbs_h = 576;
+			break;
+		case TVOUT_MODE_480I:
+		case TVOUT_MODE_480P:
+		case TVOUT_MODE_720P60:
+		case TVOUT_MODE_1080I30:
+		case TVOUT_MODE_1080P24:
+		case TVOUT_MODE_1080P30:
+		case TVOUT_MODE_1080P60:
+		case TVOUT_RGB_640X480_60FPS:
+		case TVOUT_RGB_800X600_60FPS:
+		case TVOUT_RGB_1024X768_60FPS:
+		case TVOUT_RGB_1280X720_60FPS:
+		case TVOUT_RGB_800X480_60FPS:
+		case TVOUT_RGB_1440X900_60FPS:
+		case TVOUT_RGB_1280X1024_60FPS:
+		case TVOUT_RGB_1360X768_60FPS:
+		case TVOUT_RGB_1920X1080P30:
+		case TVOUT_RGB_1920X1080P60:
+		case TVOUT_RGB_1920X1080I30:
+		case TVOUT_RGB_1366X768_60FPS:
+			tve1_mode = TVOUT_MODE_480I;
+			cvbs_h = 480;
+			break;
+		default:
+			tve1_mode = TVOUT_MODE_576I;
+			cvbs_h = 576;
+			break;
+	}
+
+	clock_dispset_clockmode0(1, tve_2_clock[tve1_mode]);
+	udelay(100);
+
+	InitTVE1Raw(tve1_mode, __Is_ColorBar);
+	udelay(100);
+
+	__df_update_start();
+	DFSetOutIFVideoFmt(1, tve_2_df[tve1_mode]);
+	__df_update_end();
+	udelay(100);
+
+	__df_update_start();
+	DFVideoEna(1, 1, cvbs_w, cvbs_h,addr);
+	__df_update_end();	
+
+}
+#endif
+#endif
+static int tve_2_clock[] = {
+	_YUV_PAL,
+	_YUV_480I_60Hz,
+	_YUV_576P_50Hz,
+	_YUV_480P_60Hz,
+	_YUV_720P_50Hz,
+	_YUV_720P_60Hz,
+	_YUV_1080I_50Hz,
+	_YUV_1080I_60Hz,
+
+	_YUV_PAL,
+	_YUV_NTSC,
+	_YUV_PAL,
+	_YUV_PAL,
+	_YUV_1080P_24Hz,
+	_YUV_1080P_25Hz,
+	_YUV_1080P_30Hz,
+	_YUV_1080P_50Hz,
+	_YUV_1080P_60Hz,
+
+	_YUV_PAL,
+	_YUV_NTSC,
+	_YUV_NTSC,
+	_YUV_480I_60Hz,
+	_YUV_576P_50Hz,
+	_YUV_480P_59p94Hz,
+	_YUV_480P_59p94Hz,
+	_YUV_480P_60Hz,
+	_YUV_720P_59p94Hz,
+	_YUV_1080I_59p94Hz,
+	_YUV_1080P_23p98Hz,
+	_YUV_1080P_59p94Hz,
+
+	_YUV_1080P_59p94Hz,
+	_YUV_1080P_60Hz,
+	_YUV_1080P_60Hz,
+	_YUV_1080P_59p94Hz,
+	_YUV_1080P_60Hz,
+
+	_YUV_1080I_50Hz,
+	_YUV_1080I_59p94Hz,
+	_YUV_1080I_60Hz,
+
+	_YUV_720P_50Hz,
+	_YUV_720P_59p94Hz,
+	_YUV_720P_60Hz,
+	_YUV_1080P_23p98Hz,
+	_YUV_1080P_24Hz,
+
+	_RGB_DMT_640x480_60Hz,
+	_RGB_DMT_800x600_60Hz,
+	_RGB_DMT_1024x768_60Hz,
+	_YUV_720P_60Hz,
+	_RGB_DMT_800x600_60Hz,
+	_RGB_DMT_1440x900_60Hz,
+	_RGB_DMT_1280x1024_60Hz,
+	_RGB_DMT_1360x768_60Hz,
+	_YUV_1080P_30Hz,
+	_YUV_1080P_60Hz,
+	_YUV_1080I_60Hz,
+	_RGB_DMT_1360x768_60Hz,
+	_RGB_DMT_640x480_59P94Hz,
+	_RGB_DMT_1600x1200_60Hz,
+};
+static int __Is_first = 1;
+static int _Is_interlace = 0;
+int __Is_TV = 1;
+void set_tv_mode(TVOUT_MODE mode)
+{
+	int tveid;
+
+	tveid=0;
+
+	if(__Is_first){
+		pinmux_set_dac0mode(_dac0_tve0_ypbpr);
+		pinmux_set_dac1mode(_dac1_tve1_cvbs_svideo);
+#ifdef CONFIG_TVOUT_YPBPR
+		clock_dac0_enaclock(_clock_enable);
+#endif
+#ifdef CONFIG_TVOUT_CVBS
+		clock_dac1_enaclock(_clock_enable);
+#endif
+		clock_df_enaclock(1);
+		clock_video_enaclock(1);
+	}
+
+	switch(mode){
+		case TVOUT_MODE_SECAM:
+		case TVOUT_MODE_PAL_N:
+		case TVOUT_MODE_PAL_M:
+		case TVOUT_MODE_PAL_CN:
+		case TVOUT_MODE_576I:
+		case TVOUT_MODE_480I:
+		case TVOUT_MODE_1080I25:
+		case TVOUT_MODE_1080I30:
+			_Is_interlace = 1;
+			break;
+		default:
+			_Is_interlace = 0;
+	}
+
+
+	switch (mode){
+		case TVOUT_MODE_SECAM:
+		case TVOUT_MODE_PAL_N:
+		case TVOUT_MODE_PAL_M:
+		case TVOUT_MODE_PAL_CN:
+		case TVOUT_MODE_576I:
+		case TVOUT_MODE_576P:
+		case TVOUT_MODE_480I:
+		case TVOUT_MODE_480P:
+		case TVOUT_MODE_720P50:
+		case TVOUT_MODE_720P60:
+		case TVOUT_MODE_1080I25:
+		case TVOUT_MODE_1080I30:
+		case TVOUT_MODE_1080P24:
+		case TVOUT_MODE_1080P25:
+		case TVOUT_MODE_1080P30:
+		case TVOUT_MODE_1080P50:
+		case TVOUT_MODE_1080P60:
+			if(DF_OUTPUT_CVBS_SVIDEO == df_output_config.output_mode[tveid]){
+				pinmux_set_dac0mode(_dac0_tve0_cvbs_svideo);
+			}
+			else{
+				pinmux_set_dac0mode(_dac0_tve0_ypbpr);
+			}
+			__Is_TV = 1;
+			break;
+		case TVOUT_RGB_640X480_60FPS:
+		case TVOUT_RGB_800X600_60FPS:
+		case TVOUT_RGB_800X480_60FPS:
+		case TVOUT_RGB_1024X768_60FPS:
+		case TVOUT_RGB_1280X720_60FPS:
+		case TVOUT_RGB_1440X900_60FPS:
+		case TVOUT_RGB_1280X1024_60FPS:
+		case TVOUT_RGB_1360X768_60FPS:
+		case TVOUT_RGB_1920X1080P30:
+		case TVOUT_RGB_1920X1080P60:
+		case TVOUT_RGB_1920X1080I30:
+		case TVOUT_RGB_1366X768_60FPS:
+			pinmux_set_dac0mode(_dac0_rgb0);
+			__Is_TV = 0;
+			break;
+
+		default:
+			break;
+	}
+	df_printf("tevid = %d, mode = %d\n",tveid,(int)mode);
+
+
+	if(0 == tveid){
+		clock_disp0_setclock(tve_2_clock[mode]);
+	}
+	else if(1 == tveid){
+		clock_disp1_setclock(tve_2_clock[mode]);
+	}
+
+	udelay(10);
+
+	if(__Is_TV){
+		if(tveid == 0){
+			InitTVE0Raw(mode, __Is_ColorBar);
+		}
+		else if(tveid == 1)
+			InitTVE1Raw(mode, __Is_ColorBar);
+
+		udelay(10);
+	}
+
+
+	df_printf("before __df_update_outif_start\n");
+
+	__df_update_outif_start();
+	df_printf("before DFSetOutIFVideoFmt\n");
+	DFSetOutIFVideoFmt(0,tve_2_df[mode],1);
+	df_printf("after DFSetOutIFVideoFmt\n");
+	__df_update_outif_end();
+	udelay(10);
+	__Is_first = 0;
+	df_printf("set tv mode finished\n");
+	return ;
+}
+
+static int initstatus = 0;
+static int per_mode = -1;
+extern int do_call_external_proc (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[]);
+
+void disp_off(void)
+{
+	char* bootargs = NULL;
+	char* temp_char = NULL;
+	//int res;
+	printf("DISABLE DISPLAY RELATED MODULES!!\n");
+	DFGfxEna(0,0,0);
+	clock_df_enaclock(0);
+	clock_tve0_enaclock(_clock_disable);
+	clock_video_enaclock(0);
+	clock_dac0_enaclock(_clock_disable);
+	UIStarted=0;
+	__Is_first = 1;
+	initstatus = 0;
+	per_mode = -1;
+
+	//res=-1;
+	//modifiy bootargs, just remove outputmode
+	temp_char = NULL;
+	// set bootargs outputmode parameter
+	bootargs = getenv("bootargs");
+	//printf("bootargs = %s\n", bootargs);
+	temp_char = strstr(bootargs,"outputmode=");
+	//printf("temp_char = %s\n",temp_char);
+	if(NULL == temp_char){
+		printf("no outputmode\n");		
+	}
+	else
+	{
+		int num1 = 0;
+		int num2 = 0;
+		int templen=0;
+		char* aaa = strchr(temp_char, '=');
+		char* bbb = strchr(temp_char, ' ');
+
+		templen=strstr(bootargs,"outputmode=")-bootargs;
+		//printf("templen=%d\n",templen);
+		num1 = aaa - bootargs;
+		//printf("num1 = %d\n",num1);
+		//printf("%s\n",aaa+1);
+		if(NULL == bbb){
+			temp_char = malloc(strlen(bootargs) + 20);
+			if(0 == temp_char){
+				printf("Not enough memory!\n");
+				return;
+			}
+			//memcpy(temp_char, bootargs, num1+1);
+			//sprintf(temp_char+num1+1,"%d",res);
+			memcpy(temp_char, bootargs, strlen(bootargs)-templen);//outputmode is at the end of bootargs
+
+		}
+		else{
+			num2 = bbb - bootargs;
+			//printf("num2 = %d\n",num2);
+			temp_char = malloc(strlen(bootargs) + 20);
+			if(0 == temp_char){
+				printf("Not enough memory!\n");
+				return;
+			}
+			/*strncpy(temp_char, bootargs, num1+1);
+			  sprintf(temp_char+num1+1,"%d",res);
+			  printf("strlen(temp_char) = %d\n",strlen(temp_char));
+			  strncat(temp_char+strlen(temp_char), bbb,strlen(bbb));*/
+
+			memcpy(temp_char,bootargs,templen);
+			memcpy(temp_char+templen,bbb+1,strlen(bbb));
+		}
+		setenv("bootargs", temp_char);
+		//sprintf(temp_char, "%d", res);
+
+		free(temp_char);
+	}
+	return;
+}
+
+unsigned int flag;
+int disp_init(TVOUT_MODE mode, int pic_w, int pic_h, int dst_x, int dst_y,unsigned char * pData,int hdcp_status, int colorspace_mode)
+{
+	DF_GFX_IMG ColorImg;
+
+
+	/*int IsGfxScalerEna;
+	  int IsFetchOneField;
+	  int IsFetchTopOnly;
+	  int IsDispInterlaced;*/
+
+	flag=0x55aa55aa;
+
+	if (initstatus) {	/* already initialized */
+		printf("DF and TVE have been already initialized\n");
+
+		//		return -1;
+	}
+	df_printf("tvmode = %d\n",mode);
+	df_printf("GFXLINEPITCHSIZE = %d,screen_w %d, screen_h %d,picture_color_mode %d\n ",GFXLINEPITCHSIZE,screen_w,screen_h,picture_color_mode);
+
+	ColorImg.StartAddress = (unsigned int)pData;//GFXBASEADDRESS;
+	ColorImg.PixelWidth = pic_w;
+	ColorImg.PixelHeight = pic_h;
+	ColorImg.ColorFormat = picture_color_mode;
+	ColorImg.DefaultAlpha = 0xff;
+	ColorImg.LinePitch = GFXLINEPITCHSIZE;
+
+
+	set_tv_mode(mode);
+
+	CS_LoadDisplay (&ColorImg);
+#if 1
+	if((mode < TVOUT_MODE_MAX)&&(per_mode !=mode)){
+		char *hdmi_argv[6]={0};
+		char mode_str[5]={0};
+		char flag_addr[4]={0};
+		char hdcp_flag[4]={0};
+		char colorspace_flag[4]= {0};
+		sprintf(mode_str,"%d",mode);
+		hdmi_argv[0]="call_external_proc";
+		hdmi_argv[1]="HDMI";
+		hdmi_argv[2]=mode_str;
+
+		unsigned int addr;
+		addr=(unsigned int )&flag;
+		flag_addr[0]=(unsigned char )(addr&0x000000ff);
+		flag_addr[1]=(unsigned char )((addr&0x0000ff00)>>8);
+		flag_addr[2]=(unsigned char )((addr&0x00ff0000)>>16);
+		flag_addr[3]=(unsigned char )((addr&0xff000000)>>24);
+		//printf("%x,%x,%x,%x,%x\n",flag_addr[0],flag_addr[1],flag_addr[2],flag_addr[3],(unsigned int )&flag);
+		hdmi_argv[3]=flag_addr;
+		sprintf(hdcp_flag,"%d",hdcp_status);
+		hdmi_argv[4]=hdcp_flag;
+		sprintf(colorspace_flag,"%d",colorspace_mode);
+		hdmi_argv[5]=colorspace_flag;
+
+		//		printf("hdmi_argv[4] %s\n",hdmi_argv[4]);
+		do_call_external_proc(NULL, 0, 6, hdmi_argv);
+	}
+#endif
+	per_mode = mode;
+	initstatus = 1;
+
+	if(!flag)
+	{
+		/*printf("DISABLE DISPLAY RELATED MODULES!!\n");
+		  DFGfxEna(0,0,0);
+		  clock_df_enaclock(0);
+		  clock_tve0_enaclock(_clock_disable);
+		  clock_video_enaclock(0);
+		  clock_dac0_enaclock(_clock_disable);
+		  UIStarted=0;*/
+		disp_off();
+
+	}
+
+	return 0;
+}
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/cnc1900/df/df.h u-boot-2011.06/drivers/cnc1900/df/df.h
